#ifndef _TULIP_H_
#define _TULIP_H_

#include <stddef.h>
#include <dev.h>

struct tulip * tulip_init(bs_seq spaces, dma_handle_t dma, bus_space_t pciconf);
int 
tulip_register_callback(struct tulip *tulip,
			void *callback_data, 
			void (*tx_freepacket) (void *, uint32_t, uint64_t),
			int (*rx_feedpacket) (void *, uint32_t, size_t, uint64_t));
int tulip_get_macaddr(struct tulip *tulip, uint8_t macaddr[6]);
int tulip_interrupt_handler(struct tulip *tulip);
int tulip_enable_receive(struct tulip *dthis);
int tulip_feedpacket(struct tulip *tulip, uint32_t buffer_addr, size_t size,
		     uint8_t first, uint8_t more, uint64_t key);
int tulip_freepacket(struct tulip *tulip, uint32_t buffer_addr, size_t size,
		     uint32_t key);

#endif /* _TULIP_H_ */
