#ifndef _UNSWR4600_IO
#define _UNSWR4600_IO

/****************************************************************************
 * MEMORY MAP for UNSW R4600 Board
 ****************************************************************************/

/*
 * This file was taken from the U4600 PMON source.
 * Originally PMON/pmon/u4600/sbd.h
 * Stolen into Mungi by ceg.
 */


/* initial decode setup */
/* DRAM banks */

#ifndef DRAM10_BASE
#define DRAM10_BASE    0x00000000     /* 64M */
#define DRAM32_BASE    0x04000000     /* 64M */
#define DRAM_END       0x08000000

/* DRAM and DEVICE ADDRESS MAP */
#define DRAM0_BASE     0x00000000    /* 32M */
#define DRAM1_BASE     0x02000000    /* 32M */
#define DRAM2_BASE     0x04000000    /* 32M */
#define DRAM3_BASE     0x06000000    /* 32M */
#define DRAM_END       0x08000000

#define LOCAL_MEM_SIZE  0x10000000

#endif

/* PCI decode */
#define PCI_IO_BASE    0x10000000    /* 32M */
#define PCI_IO_END     0x12000000
#define PCI_MEM_BASE   0x12000000    /* 32M */
#define PCI_MEM_END    0x14000000

#define PCI_MEM_SPACE PCI_MEM_BASE
#define PCI_IO_SPACE  PCI_IO_BASE
#define PCI_MEM_SPACE_SIZE	(32 * 1024 * 1024)
#define PCI_IO_SPACE_SIZE	(32  * 1024 * 1024)

/* Device Banks */
#define CS210_BASE    0x1c000000
#define CS210_END     0x1e200000
#define CS3B_BASE     0x1f000000
#define CS3B_END      0x20000000


#define CS0_BASE      0x1c000000
#define CS1_BASE      0x1c800000
#define CS2_BASE      0x1d000000
#define CS3_BASE      0x1f000000
#define BOOT_BASE     0x1fc00000

/* PERIPHERAL Address map */
#define RTCLOCK_BASE   CS0_BASE

#define LED_BASE       (CS1_BASE)
#define IO_PINS_BASE   (CS1_BASE | 0x10)
#define PCI_INT_BASE   (CS1_BASE | 0x20)
#define z85230_BASE    (CS1_BASE | 0x30)

/* PCI interrupt decoder offsets. added by ceg */
#define PCI_INT_BITS    (0x20)
#define PCI_INT_INT_LO  (0)
#define PCI_INT_INT_HI  (1)
#define PCI_INT_MASK_LO (2)
#define PCI_INT_MASK_HI (3)


/* TIMING for BOOT BANK with M27C4002-10 */

#define EPROM_TurnOff     3
#define EPROM_AccToFirst  5
#define EPROM_AccToNext   5

/* TIMING for BANK 0 with M48T02-150 */
#define M48_TurnOff       3 /* GT minimum */
#define M48_AccToFirst    8
#define M48_AccToNext     8
#define M48_ADStoWr       3  
#define M48_WrActive      5
#define M48_WrHigh        3

   

#endif
