#ifndef _2114N_H_
#define _2114N_H_

#include "2114n_types.reg.h"

#include <io.h>

#define UserPrint l4e_printf

static inline union bus_mode read_bus_mode(bus_space_t bus) {
	union bus_mode foo;
	foo.data = io_read_32(bus, 0);
	return foo;
}

#define READ_BUS_MODE() read_bus_mode(dthis->csr)

static inline void write_bus_mode(bus_space_t bus, union bus_mode foo) {
	return io_write_32 (bus, (0), foo.data);
}

#define WRITE_BUS_MODE(foo) write_bus_mode(dthis->csr, foo)

static inline union send_poll read_send_poll(bus_space_t bus) {
	union send_poll foo;
	foo.data = io_read_32(bus, 8);
	return foo;
}

#define READ_SEND_POLL() read_send_poll(dthis->csr)

static inline void write_send_poll(bus_space_t bus, union send_poll foo) {
	return io_write_32 (bus, (8), foo.data);
}

#define WRITE_SEND_POLL(foo) write_send_poll(dthis->csr, foo)

static inline union rcv_poll read_rcv_poll(bus_space_t bus) {
	union rcv_poll foo;
	foo.data = io_read_32(bus, 16);
	return foo;
}

#define READ_RCV_POLL() read_rcv_poll(dthis->csr)

static inline void write_rcv_poll(bus_space_t bus, union rcv_poll foo) {
	return io_write_32 (bus, (16), foo.data);
}

#define WRITE_RCV_POLL(foo) write_rcv_poll(dthis->csr, foo)

static inline union rcv_ring read_rcv_ring(bus_space_t bus) {
	union rcv_ring foo;
	foo.data = io_read_32(bus, 24);
	return foo;
}

#define READ_RCV_RING() read_rcv_ring(dthis->csr)

static inline void write_rcv_ring(bus_space_t bus, union rcv_ring foo) {
	return io_write_32 (bus, (24), foo.data);
}

#define WRITE_RCV_RING(foo) write_rcv_ring(dthis->csr, foo)

static inline union send_ring read_send_ring(bus_space_t bus) {
	union send_ring foo;
	foo.data = io_read_32(bus, 32);
	return foo;
}

#define READ_SEND_RING() read_send_ring(dthis->csr)

static inline void write_send_ring(bus_space_t bus, union send_ring foo) {
	return io_write_32 (bus, (32), foo.data);
}

#define WRITE_SEND_RING(foo) write_send_ring(dthis->csr, foo)

static inline union status read_status(bus_space_t bus) {
	union status foo;
	foo.data = io_read_32(bus, 40);
	return foo;
}

#define READ_STATUS() read_status(dthis->csr)

static inline void write_status(bus_space_t bus, union status foo) {
	return io_write_32 (bus, (40), foo.data);
}

#define WRITE_STATUS(foo) write_status(dthis->csr, foo)

static inline union op_mode read_op_mode(bus_space_t bus) {
	union op_mode foo;
	foo.data = io_read_32(bus, 48);
	return foo;
}

#define READ_OP_MODE() read_op_mode(dthis->csr)

static inline void write_op_mode(bus_space_t bus, union op_mode foo) {
	return io_write_32 (bus, (48), foo.data);
}

#define WRITE_OP_MODE(foo) write_op_mode(dthis->csr, foo)

static inline union irq_mask read_irq_mask(bus_space_t bus) {
	union irq_mask foo;
	foo.data = io_read_32(bus, 56);
	return foo;
}

#define READ_IRQ_MASK() read_irq_mask(dthis->csr)

static inline void write_irq_mask(bus_space_t bus, union irq_mask foo) {
	return io_write_32 (bus, (56), foo.data);
}

#define WRITE_IRQ_MASK(foo) write_irq_mask(dthis->csr, foo)

static inline union srom_mii read_srom_mii(bus_space_t bus) {
	union srom_mii foo;
	foo.data = io_read_32(bus, 72);
	return foo;
}

#define READ_SROM_MII() read_srom_mii(dthis->csr)

static inline void write_srom_mii(bus_space_t bus, union srom_mii foo) {
	return io_write_32 (bus, (72), foo.data);
}

#define WRITE_SROM_MII(foo) write_srom_mii(dthis->csr, foo)

static inline union sia_conn read_sia_conn(bus_space_t bus) {
	union sia_conn foo;
	foo.data = io_read_32(bus, 104);
	return foo;
}

#define READ_SIA_CONN() read_sia_conn(dthis->csr)

static inline void write_sia_conn(bus_space_t bus, union sia_conn foo) {
	return io_write_32 (bus, (104), foo.data);
}

#define WRITE_SIA_CONN(foo) write_sia_conn(dthis->csr, foo)

static inline union sia_txrx read_sia_txrx(bus_space_t bus) {
	union sia_txrx foo;
	foo.data = io_read_32(bus, 112);
	return foo;
}

#define READ_SIA_TXRX() read_sia_txrx(dthis->csr)

static inline void write_sia_txrx(bus_space_t bus, union sia_txrx foo) {
	return io_write_32 (bus, (112), foo.data);
}

#define WRITE_SIA_TXRX(foo) write_sia_txrx(dthis->csr, foo)

static inline union sia_general read_sia_general(bus_space_t bus) {
	union sia_general foo;
	foo.data = io_read_32(bus, 120);
	return foo;
}

#define READ_SIA_GENERAL() read_sia_general(dthis->csr)

static inline void write_sia_general(bus_space_t bus, union sia_general foo) {
	return io_write_32 (bus, (120), foo.data);
}

#define WRITE_SIA_GENERAL(foo) write_sia_general(dthis->csr, foo)

static inline void print_bus_mode ( union bus_mode reg ) {	UserPrint("Debug bus_mode - 0x%x\n", reg.data);	if (reg.r.swr != 0) {
		UserPrint("\tswr: %x\n", reg.r.swr);
	}
	if (reg.r.bar != 0) {
		UserPrint("\tbar: %x\n", reg.r.bar);
	}
	if (reg.r.dsl != 0) {
		UserPrint("\tdsl: %x\n", reg.r.dsl);
	}
	if (reg.r.ble != 0) {
		UserPrint("\tble: %x\n", reg.r.ble);
	}
	if (reg.r.pbl != 0) {
		UserPrint("\tpbl: %x\n", reg.r.pbl);
	}
	if (reg.r.cal != 0) {
		UserPrint("\tcal: %x\n", reg.r.cal);
	}
	if (reg.r.das != 0) {
		UserPrint("\tdas: %x\n", reg.r.das);
	}
	if (reg.r.tap != 0) {
		UserPrint("\ttap: %x\n", reg.r.tap);
	}
	if (reg.r.dbo != 0) {
		UserPrint("\tdbo: %x\n", reg.r.dbo);
	}
}

static inline void print_send_poll ( union send_poll reg ) {	UserPrint("Debug send_poll - 0x%x\n", reg.data);}

static inline void print_rcv_poll ( union rcv_poll reg ) {	UserPrint("Debug rcv_poll - 0x%x\n", reg.data);}

static inline void print_rcv_ring ( union rcv_ring reg ) {	UserPrint("Debug rcv_ring - 0x%x\n", reg.data);}

static inline void print_send_ring ( union send_ring reg ) {	UserPrint("Debug send_ring - 0x%x\n", reg.data);}

static inline void print_status ( union status reg ) {	UserPrint("Debug status - 0x%x\n", reg.data);	if (reg.r.ti != 0) {
		UserPrint("\tti: %x\n", reg.r.ti);
	}
	if (reg.r.tps != 0) {
		UserPrint("\ttps: %x\n", reg.r.tps);
	}
	if (reg.r.tu != 0) {
		UserPrint("\ttu: %x\n", reg.r.tu);
	}
	if (reg.r.tjt != 0) {
		UserPrint("\ttjt: %x\n", reg.r.tjt);
	}
	if (reg.r.lnp_anc != 0) {
		UserPrint("\tlnp_anc: %x\n", reg.r.lnp_anc);
	}
	if (reg.r.unf != 0) {
		UserPrint("\tunf: %x\n", reg.r.unf);
	}
	if (reg.r.ri != 0) {
		UserPrint("\tri: %x\n", reg.r.ri);
	}
	if (reg.r.ru != 0) {
		UserPrint("\tru: %x\n", reg.r.ru);
	}
	if (reg.r.rps != 0) {
		UserPrint("\trps: %x\n", reg.r.rps);
	}
	if (reg.r.rwt != 0) {
		UserPrint("\trwt: %x\n", reg.r.rwt);
	}
	if (reg.r.gte != 0) {
		UserPrint("\tgte: %x\n", reg.r.gte);
	}
	if (reg.r.lnf != 0) {
		UserPrint("\tlnf: %x\n", reg.r.lnf);
	}
	if (reg.r.fbe != 0) {
		UserPrint("\tfbe: %x\n", reg.r.fbe);
	}
	if (reg.r.eri != 0) {
		UserPrint("\teri: %x\n", reg.r.eri);
	}
	if (reg.r.ais != 0) {
		UserPrint("\tais: %x\n", reg.r.ais);
	}
	if (reg.r.nis != 0) {
		UserPrint("\tnis: %x\n", reg.r.nis);
	}
	if (reg.r.rs != 0) {
		UserPrint("\trs: %x\n", reg.r.rs);
	}
	if (reg.r.ts != 0) {
		UserPrint("\tts: %x\n", reg.r.ts);
	}
	if (reg.r.eb != 0) {
		UserPrint("\teb: %x\n", reg.r.eb);
	}
}

static inline void print_op_mode ( union op_mode reg ) {	UserPrint("Debug op_mode - 0x%x\n", reg.data);	if (reg.r.hash_perfect != 0) {
		UserPrint("\thash_perfect: %x\n", reg.r.hash_perfect);
	}
	if (reg.r.start_rcv != 0) {
		UserPrint("\tstart_rcv: %x\n", reg.r.start_rcv);
	}
	if (reg.r.hash_only != 0) {
		UserPrint("\thash_only: %x\n", reg.r.hash_only);
	}
	if (reg.r.pass_bad_frames != 0) {
		UserPrint("\tpass_bad_frames: %x\n", reg.r.pass_bad_frames);
	}
	if (reg.r.inverse_filter != 0) {
		UserPrint("\tinverse_filter: %x\n", reg.r.inverse_filter);
	}
	if (reg.r.promisc != 0) {
		UserPrint("\tpromisc: %x\n", reg.r.promisc);
	}
	if (reg.r.pass_multi != 0) {
		UserPrint("\tpass_multi: %x\n", reg.r.pass_multi);
	}
	if (reg.r.full_duplex != 0) {
		UserPrint("\tfull_duplex: %x\n", reg.r.full_duplex);
	}
	if (reg.r.operating_mode != 0) {
		UserPrint("\toperating_mode: %x\n", reg.r.operating_mode);
	}
	if (reg.r.start_send != 0) {
		UserPrint("\tstart_send: %x\n", reg.r.start_send);
	}
	if (reg.r.threshold_ctrl != 0) {
		UserPrint("\tthreshold_ctrl: %x\n", reg.r.threshold_ctrl);
	}
}

static inline void print_irq_mask ( union irq_mask reg ) {	UserPrint("Debug irq_mask - 0x%x\n", reg.data);	if (reg.r.tim != 0) {
		UserPrint("\ttim: %x\n", reg.r.tim);
	}
	if (reg.r.tsm != 0) {
		UserPrint("\ttsm: %x\n", reg.r.tsm);
	}
	if (reg.r.tum != 0) {
		UserPrint("\ttum: %x\n", reg.r.tum);
	}
	if (reg.r.tjm != 0) {
		UserPrint("\ttjm: %x\n", reg.r.tjm);
	}
	if (reg.r.lpm != 0) {
		UserPrint("\tlpm: %x\n", reg.r.lpm);
	}
	if (reg.r.unm != 0) {
		UserPrint("\tunm: %x\n", reg.r.unm);
	}
	if (reg.r.rim != 0) {
		UserPrint("\trim: %x\n", reg.r.rim);
	}
	if (reg.r.rum != 0) {
		UserPrint("\trum: %x\n", reg.r.rum);
	}
	if (reg.r.rsm != 0) {
		UserPrint("\trsm: %x\n", reg.r.rsm);
	}
	if (reg.r.rwm != 0) {
		UserPrint("\trwm: %x\n", reg.r.rwm);
	}
	if (reg.r.tmm != 0) {
		UserPrint("\ttmm: %x\n", reg.r.tmm);
	}
	if (reg.r.lfm != 0) {
		UserPrint("\tlfm: %x\n", reg.r.lfm);
	}
	if (reg.r.sem != 0) {
		UserPrint("\tsem: %x\n", reg.r.sem);
	}
	if (reg.r.erm != 0) {
		UserPrint("\term: %x\n", reg.r.erm);
	}
	if (reg.r.aim != 0) {
		UserPrint("\taim: %x\n", reg.r.aim);
	}
	if (reg.r.nim != 0) {
		UserPrint("\tnim: %x\n", reg.r.nim);
	}
}

static inline void print_srom_mii ( union srom_mii reg ) {	UserPrint("Debug srom_mii - 0x%x\n", reg.data);	if (reg.r.cs != 0) {
		UserPrint("\tcs: %x\n", reg.r.cs);
	}
	if (reg.r.clk != 0) {
		UserPrint("\tclk: %x\n", reg.r.clk);
	}
	if (reg.r.dout != 0) {
		UserPrint("\tdout: %x\n", reg.r.dout);
	}
	if (reg.r.din != 0) {
		UserPrint("\tdin: %x\n", reg.r.din);
	}
	if (reg.r.reg != 0) {
		UserPrint("\treg: %x\n", reg.r.reg);
	}
	if (reg.r.sr != 0) {
		UserPrint("\tsr: %x\n", reg.r.sr);
	}
	if (reg.r.br != 0) {
		UserPrint("\tbr: %x\n", reg.r.br);
	}
	if (reg.r.wr != 0) {
		UserPrint("\twr: %x\n", reg.r.wr);
	}
	if (reg.r.rd != 0) {
		UserPrint("\trd: %x\n", reg.r.rd);
	}
}

static inline void print_sia_conn ( union sia_conn reg ) {	UserPrint("Debug sia_conn - 0x%x\n", reg.data);	if (reg.r.srl != 0) {
		UserPrint("\tsrl: %x\n", reg.r.srl);
	}
	if (reg.r.cac != 0) {
		UserPrint("\tcac: %x\n", reg.r.cac);
	}
	if (reg.r.aui != 0) {
		UserPrint("\taui: %x\n", reg.r.aui);
	}
	if (reg.r.sdm != 0) {
		UserPrint("\tsdm: %x\n", reg.r.sdm);
	}
}

static inline void print_sia_txrx ( union sia_txrx reg ) {	UserPrint("Debug sia_txrx - 0x%x\n", reg.data);	if (reg.r.ecen != 0) {
		UserPrint("\tecen: %x\n", reg.r.ecen);
	}
	if (reg.r.lbk != 0) {
		UserPrint("\tlbk: %x\n", reg.r.lbk);
	}
	if (reg.r.dren != 0) {
		UserPrint("\tdren: %x\n", reg.r.dren);
	}
	if (reg.r.lse != 0) {
		UserPrint("\tlse: %x\n", reg.r.lse);
	}
	if (reg.r.cpen != 0) {
		UserPrint("\tcpen: %x\n", reg.r.cpen);
	}
	if (reg.r.mbo != 0) {
		UserPrint("\tmbo: %x\n", reg.r.mbo);
	}
	if (reg.r.ane != 0) {
		UserPrint("\tane: %x\n", reg.r.ane);
	}
	if (reg.r.rsq != 0) {
		UserPrint("\trsq: %x\n", reg.r.rsq);
	}
	if (reg.r.csq != 0) {
		UserPrint("\tcsq: %x\n", reg.r.csq);
	}
	if (reg.r.cld != 0) {
		UserPrint("\tcld: %x\n", reg.r.cld);
	}
	if (reg.r.sqe != 0) {
		UserPrint("\tsqe: %x\n", reg.r.sqe);
	}
	if (reg.r.lte != 0) {
		UserPrint("\tlte: %x\n", reg.r.lte);
	}
	if (reg.r.ape != 0) {
		UserPrint("\tape: %x\n", reg.r.ape);
	}
	if (reg.r.spp != 0) {
		UserPrint("\tspp: %x\n", reg.r.spp);
	}
	if (reg.r.tas != 0) {
		UserPrint("\ttas: %x\n", reg.r.tas);
	}
}

static inline void print_sia_general ( union sia_general reg ) {	UserPrint("Debug sia_general - 0x%x\n", reg.data);	if (reg.r.jbd != 0) {
		UserPrint("\tjbd: %x\n", reg.r.jbd);
	}
	if (reg.r.huj != 0) {
		UserPrint("\thuj: %x\n", reg.r.huj);
	}
	if (reg.r.jck != 0) {
		UserPrint("\tjck: %x\n", reg.r.jck);
	}
	if (reg.r.abm != 0) {
		UserPrint("\tabm: %x\n", reg.r.abm);
	}
	if (reg.r.rwd != 0) {
		UserPrint("\trwd: %x\n", reg.r.rwd);
	}
	if (reg.r.rwr != 0) {
		UserPrint("\trwr: %x\n", reg.r.rwr);
	}
	if (reg.r.le1 != 0) {
		UserPrint("\tle1: %x\n", reg.r.le1);
	}
	if (reg.r.lv1 != 0) {
		UserPrint("\tlv1: %x\n", reg.r.lv1);
	}
	if (reg.r.tsck != 0) {
		UserPrint("\ttsck: %x\n", reg.r.tsck);
	}
	if (reg.r.fusq != 0) {
		UserPrint("\tfusq: %x\n", reg.r.fusq);
	}
	if (reg.r.flf != 0) {
		UserPrint("\tflf: %x\n", reg.r.flf);
	}
	if (reg.r.lsd != 0) {
		UserPrint("\tlsd: %x\n", reg.r.lsd);
	}
	if (reg.r.dpst != 0) {
		UserPrint("\tdpst: %x\n", reg.r.dpst);
	}
	if (reg.r.frl != 0) {
		UserPrint("\tfrl: %x\n", reg.r.frl);
	}
	if (reg.r.le2 != 0) {
		UserPrint("\tle2: %x\n", reg.r.le2);
	}
	if (reg.r.lv2 != 0) {
		UserPrint("\tlv2: %x\n", reg.r.lv2);
	}
}

#endif /* _2114N_H_ */
